program World;
{$M 8192,0,0}           { Leave memory for child process }

uses crt,dos;

const MaxLevel=50;

type
 Tab = ARRAY [0..MaxLevel-1] of byte;
 Tab2 = ARRAY [0..MaxLevel-1] of string[15];
 Couple = ARRAY [0..1] of byte;

label LabelError,NoDel;

var
 F: Text;
 F1, F2 : file of byte;
 i,j,k,N, Decalage,Decalage2,MkName: Integer;
 Ch: char;
 Bt: byte;
 Cpl: Couple;
 FileName,s,s2,GraphName,Comment,ShellStr,AddOnStr,CompStr,OSStr:String [100];
 DelOk: BOOLEAN;

 Tipe:tab;
 Name:tab2;

function Upper(s:string):string;
var i:integer;
begin
for i := 1 to Length(s) do
  s[i] := UpCase(s[i]);
Upper:=s;
end;

function Lower(s:string):string;
var i:integer; c:char;
begin
for i := 1 to length(s) do
    if (s[i] >= 'A') and (s[i] <= 'Z') then
                 s[i] := chr( ord(s[i]) + ord('a') - ord('A'));
lower:=s;
end;

function IntToStr(I: Longint): String;
{ Convert any integer type to a string }
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

function StrToInt(s:string): integer;
var i,code:integer;
begin
  Val(s,i,code);
  StrToInt:=i;
end;

function DestroyExt(s:string):string;
var
   i:integer;
begin
    i:=Pos('.',s);
    if i>0 then DestroyExt:=Copy(s,1,i-1) else DestroyExt:=s;
end;

function DestroyPatch(s:string):string;
var
   i:integer;
begin
    i:=Pos('\',s);
    if i>0 then DestroyPatch:=DestroyPatch(Copy(s,i+1,length(s))) else DestroyPatch:=s;
end;

Procedure ReturnCouple(s:string);
var
   i:integer;
begin
   i:=Pos(' ',s);
   Cpl[0]:=StrToInt(copy(s,1,i-1));
   Cpl[1]:=StrToInt(copy(s,i+1,length(s)));
end;

function FileExists(FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;  { Set file access to read only }
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

begin
 Decalage:= 86;
 Decalage2:=12+16;
 MkName:=0;
 DelOk:=true;

 clrscr;
 Writeln('MkWorld v0.32 by Pelissier Patrick');
 Writeln('Make a 92P/9XZ/89Z world for Fernando 3-C');
 Writeln;

if ParamStr(1)='' then
 begin
 Writeln('Use MkWorld FileName.wld');
 writeln('Code   : PLAY / NAME / SHLL / GRPH / LOAD / JUMP / JKEY / ADDO / BIGL');
 writeln('Option : NODL / OFST / OFS2 / COMP / STOS');
 end
else
 begin
 {Set some data}
 FileName:=DestroyPatch(DestroyExt(ParamStr(1)));
 GraphName:='';
 ShellStr:=ParamStr(2);
 AddOnStr:='';
 CompStr:='packer92 -n';
 OSStr:='';

 {Lecture du fichier Monde}
 s:=FileName+'.WLD';
 writeln('Reading :',s);
 if not(FileExists(s)) then goto LabelError;
 Assign(F,s);
 Reset(F);
 i:=0;
 while (i<MaxLevel) and (Not(Eof(F))) do
  begin
  Readln(F,s);
  s:=Upper(s);
  s2:=copy(s,1,4);
  s:=copy(s,6,length(s));
  if s2='GRPH' then GraphName:=s
  else if s2='PLAY' then begin
                          Tipe[i]:=0;
                          Name[i]:=s;
                          i:=i+1;
                         end
  else if s2='NAME' then comment:=s
  else if s2='SHLL' then shellstr:=s
  else if s2='LOAD' then
                        begin
                        Tipe[i]:=1;
                        Name[i]:=s;
                        i:=i+1;
                        end
  else if s2='OFST' then decalage:=StrToInt(s)
  else if s2='OFS2' then decalage2:=StrToInt(s)
  else if s2='JUMP' then
                    begin
                       Tipe[i]:=0;
                       Name[i]:='FILE'+IntToStr(MkName)+'.$$$';
                       assign(F1,Name[i]);
                       rewrite(F1);
                       Bt:=0; Write(F1,Bt);
                       Bt:=4; Write(F1,Bt);
                       Bt:=0; Write(F1,Bt);
                       Bt:=StrToInt(s); Write(F1,Bt);
                       close(F1);
                       MkName:=MkName+1;
                       i:=i+1;
                    end
  else if s2='JKEY' then
                    begin
                       Tipe[i]:=0;
                       Name[i]:='FILE'+IntToStr(MkName)+'.$$$';
                       assign(F1,Name[i]);
                       rewrite(F1);
                       Bt:=0; Write(F1,Bt);
                       Bt:=6; Write(F1,Bt);
                       Bt:=0; Write(F1,Bt);
                       Bt:=StrToInt(s); Write(F1,Bt);
                       close(F1);
                       MkName:=MkName+1;
                       i:=i+1;
                    end
  else if s2='ADDO' then
                      AddOnStr:=s
  else if s2='NODL' then DelOk:=false
  else if s2='COMP' then CompStr:=Lower(s)
  else if s2='STOS' then OSStr:=s
  else if s2='BIGL' then
                      begin
                       Tipe[i]:=0;
                       Name[i]:='FILE'+IntToStr(MkName)+'.$$$';
                       assign(F1,Name[i]);
                       rewrite(F1);
                       Bt:=0; Write(F1,Bt);
                       Bt:=8; Write(F1,Bt);
                       Bt:=0; Write(F1,Bt);
                       ReturnCouple(s);
                       Write(F1,Cpl[0]);
                       Write(F1,Bt);
                       Write(F1,Cpl[1]);
                       close(F1);
                       MkName:=MkName+1;
                       i:=i+1;
                      end
  else if s2='' then writeln('Void')
  else writeln('Can''t understand :',s2);
  end;

 close(F);

  {Lecture termine : verification des paramtres}
  if (GraphName='') or (shellstr='') then
     goto LabelError;
  Writeln('Graph Name: ',GraphName);
  Writeln('Comment   : ',Comment);
  Writeln('Shell     : ',shellstr);
  Writeln('Comp      : ',compstr);
  Writeln('Offset of the start of the Aux-files : ',decalage);
  Writeln('Offset2 for the Aux-Files : ',decalage2);
  Writeln('OS        : ',OSStr);
  if DelOk then writeln('Del all temp files.')
           else writeln('Don''t del temp files.');
  Writeln;

  { Convertit les fichiers 92P ou 9XZ en leur prlevant le code}

  for j:=0 to (i-1) do
      begin
      if Tipe[j]=1 then begin
                        s:=Name[j];
                        if not(FileExists(s)) then goto LabelError;
                        Assign(F1,s);
                        Name[j]:=DestroyExt(Name[j])+'.$$$';
                        writeln('Creating ',Name[j]);
                        Assign(F2,Name[j]);
                        Reset(F1);
                        ReWrite(F2);
                        { Skip the first bytes }
                        for k:=1 to Decalage do
                            Read(F1,Bt);
                        { Extract the code}
                        while not eof(F1) do
                              begin
                                  Read(F1,Bt);
                                  Write(F2,Bt);
                              end;
                        Close(F1);
                        { Add some bytes : why ? I don't know}
                        Bt:=255;
                        for k:=1 to Decalage2 do
                            Write(F2,Bt);
                        Close(F2);
                        end;
      end;
  { fabrique un petit fichier os.h si besoin}
  if OSStr<>'' then
               begin
               assign(F,'os.h');
               ReWrite(F);
               writeln(F,'; Include file genrated by MkWorld');
               writeln(F,'; Set some option');
               write(F,'OS EQU ');
               writeln(F,OSStr);
               close(F);
               end;

  { Fabrique le fichier pour packer92 ou autre}
  writeln('Making FileList.par for ',CompStr);
  s:=CompStr+' @FileList.$$$ '+FileName+'.$$$';
  Assign(F,'filelist.$$$');
  ReWrite(F);
  Writeln(F,GraphName);
  for j:=0 to (i-1) do
      begin
        Writeln(F,Name[j]);
        writeln(Tipe[j],'-',Name[j]);
      end;
  Close(F);

  writeln('All done !');
  Writeln;

  {Fabrique le fichier ASM}
  writeln('Creating ',FileName,'.ASM...');
  Assign(F,FileName+'.ASM');
  ReWrite(F);
  If AddOnStr<>'' then Writeln(F,' include ',AddOnStr);
  Writeln(F,'	xdef	_main');
  Writeln(F,'	xdef	_comment');
  Writeln(F,'_main:');
  if AddOnStr<>'' then
                  begin
                      Writeln(F,' lea    SpriteInit(PC),a0');
                      Writeln(F,' move.l a0,fer3c::InitAddOnADR');
                      Writeln(F,' lea    SpriteExec(PC),a0');
                      Writeln(F,' move.l a0,fer3c::ExecAddOnADR');
                  end;
  writeln(F,' lea        Start(PC),a0');
  Writeln(F,' jmp        fer3c@0000');
  Write(F,'Start: dc.w       ');
  Writeln(F,IntToStr(i));
  Write(F,' INCBIN	');
  Write(F,FileName);
  Writeln(F,'.$$$');
  Write(F,'_comment:	dc.b	"');
  Write(F,Comment);
  Writeln(F,'",0');
  Writeln(F,' end');
  Close(F);
  writeln('ASM file created !');
  writeln;

  writeln('Starting ',CompStr,' & ',shellstr);

  SwapVectors;
  Exec(GetEnv('COMSPEC'), '/C '+s);
  Exec(GetEnv('COMSPEC'), '/C '+shellstr+' '+FileName);
  if not(DelOk) then goto NoDel;
  Exec(GetEnv('COMSPEC'), '/C del '+FileName+'.ASM');
  Exec(GetEnv('COMSPEC'), '/C del '+FileName+'.INC');
  Exec(GetEnv('COMSPEC'), '/C del *.$$$');
NoDel:
  SwapVectors;
  if DosError <> 0 then
     WriteLn('Could not execute COMMAND.COM, DosError :',DosError);
 s:='';
LabelError:
 if s<>'' then writeln('File not found : ',s)
 else if GraphName='' then writeln('graph-file-name not found (example : GRPH graph.d32)')
 else if shellstr='' then writeln('shell-file-name not found (example : shll fargo)');
 end;
end.
