{Sprite.PAS}
{ Il reste  vrifier la prsence de la souris}

uses Crt;

const
 MAXx = 16;
 MAXy = 16;
 MAXDRAW = 256;
 MAXD = 2;
 TAILLE = 4;

type
 Tab = ARRAY [0..MAXx-1] of array [0..MAXy-1] of byte;
 BigTab = ARRAY [0..MAXD-1] of array [0..MAXy-1] of array [0..MAXDRAW-1] of byte;

label
     DebutEdition;

var
 C: Char;
 T,Temp: Tab;
 Mem: BigTab;
 F: Text;
 Ch: Char;
 s : String;
 xresolution,yresolution,video_seg,MouseX,MouseY,Button
 ,i,j,k,l,No:word;
 Continuer : BOOLEAN;
 OrigMode : Integer;

function FileExists(FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;  { Set file access to read only }
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

procedure SaveDraw(No: integer);
var
 i,j,k:Integer;
 c:Byte;
begin
 for j:=0 to MAXy - 1 do
  for i:=0 to MAXD - 1 do
      begin
       c:=T[8*i][j]*128+T[8*i+1][j]*64+T[8*i+2][j]*32+
           T[8*i+3][j]*16+T[8*i+4][j]*8+T[8*i+5][j]*4+
            T[8*i+6][j]*2+T[8*i+7][j];
       Mem[i][j][No]:=c;
      end;
end;

procedure OpenDraw(No: integer);
var
 i,j,k:Integer;
 c,d:Byte;
begin
 for j:=0 to MAXy - 1 do
  for i:=0 to MAXD - 1 do
      begin
       c:=Mem[i][j][No];
       d:=1;
       for k := 0 to 7 do
        begin
         if (c and d) = 0 then T[8*i+7-k][j]:=0
                          else T[8*i+7-k][j]:=1;
         d:=2*d;
        end;
      end;
end;

procedure SaveFile(FileName: String);
var
 F: Text;
 i,j,k,p: Integer;
 Ch: char;

begin
 Assign(F,FileName);
 ReWrite(F);
 k:=0;
 p:=1;

{
        Petit suplment pour Sprite 32 exclusivement !!!
        Utiliser { pour l'enlever.
}
{ for i:=1 to MAXD*MAXy do
     write(F,chr(0));
 }
 while (k<MAXDRAW) and (p>0) do
  begin
    p:=0;
    for j := 0 to MAXy - 1 do
        for i := 0 to (MAXD - 1) do
            p:=p+Mem[i][j][k];
    if p>0 then
     begin
       for j := 0 to MAXy - 1 do
        for i := 0 to (MAXD - 1) do
            Begin
            Ch := chr(Mem[i][j][k]);
            Write(F, Ch);
            end;
     end;
    k:= k + 1;
  end;
 Close(F);
end;

procedure OpenFile(FileName: String);
var
 F: Text;
 i,j,k: Integer;
 Ch: char;

begin
 Assign(F,FileName);
 Reset(F);
 k:=0;
{
        Petit suplment pour Sprite 32 exclusivement !!!
        Utiliser { pour l'enlever.
}
{ for i:=1 to MAXD*MAXy do
     read(F,Ch);
 }
 while (not Eof(F)) and (k<MAXDRAW) do
  begin
    for j := 0 to MAXy - 1 do
        for i := 0 to (MAXD - 1) do
            Begin
            Read(F, Ch);
            Mem[i][j][k] := ord(ch);
            end;
    k:= k + 1;
  end;
end;

procedure init_Mcga;
begin
yresolution:=200;
xresolution:=320;
video_seg:=$A000;
asm
mov xresolution,320d
mov ax,13h
int 10h
end
end;

procedure DrawMouse; assembler;
asm
mov ax,1
int $33
end;

procedure MaskMouse; assembler;
asm
mov ax,2
int $33
end;

procedure ReadMouse; assembler;
asm
mov ax,3
int $33
mov MouseX,cx
mov MouseY,dx
mov Button,bx
end;

procedure sp(xl,yl,coul:word); assembler;
asm
 mov ax,yl
 mul xresolution
 mov bx,xl
 add bx,ax
 mov es,video_seg
 mov ax,coul
 mov es:[bx],al
end;

procedure box(xl,yl,xl1,yl1,coul:word);assembler;
var i:word;
label a,b;
asm
 mov es,video_seg
 mov dx,xl
 mov i,dx
 a:
 mov Cx,yl
 b:
 mov ax,cx
 mul xresolution
 mov bx,i
 add bx,ax

 mov ax,coul
 mov es:[bx],al
 inc cx
 cmp cx,yl1
 jbe b
 inc i
 mov dx,i
 cmp dx,xl1
 jbe a
end;
{
procedure PrintGraph(No:integer);
var i,j,k:integer;
c,d,coul:byte;

begin
    for j:=0 to MAXy-1 do
        for i:=0 to MAXd-1 do
            begin
                 c:=Mem[i][j][No];
                 d:=1;
                 for k := 0 to 7 do
                     begin
                          if (c and d) = 0 then coul:=18
                             else coul:=75;
                          d:=2*d;
                          sp(i*8+7-k+200,j,coul);
                     end;
              end;
end;
}
procedure PrintGraph(No,xj,yj:integer);
var i,j:integer;
c:byte;

label Boucle,B18;

begin
    for j:=0 to MAXy-1 do
        for i:=0 to MAXd-1 do
            begin
                  c:=Mem[i][j][No];
                  asm
                   mov ax,j
                   add ax,yj
                   mul xresolution
                   mov bx,ax
                   mov ax,i
                   add ax,ax
                   add ax,ax
                   add ax,ax
                   add bx,xj
                   add bx,ax
                   mov ah,c
                   mov es,video_seg
                   mov cx,7
Boucle:
                   mov al,18
                   mov dx,1
                   sal dx,cl
                   and dl,ah
                   je  B18
                   mov al,75
B18:
                   mov es:[bx],al
                   inc bx
                   dec cx
                   cmp cx,-1
                   jne Boucle
                  end;
              end;
end;


procedure PrintTab;
var i,j:integer;
    it,jt:integer;
begin
jt:=0;
for j:= 0 to MAXy - 1 do
 begin
 it:=0;
 for i:=0 to MAXx - 1 do
         begin
             if T[i][j]=0 then
             box(it,jt,it+TAILLE,jt+TAILLE,18)
             else
             box(it,jt,it+TAILLE,jt+TAILLE,75);
             it:=it+TAILLE;
         end;
 jt:=jt+TAILLE;
 end;
end;

procedure CopyT;
var i,j:integer;
begin
 for i:=0 to MAXx - 1 do
     for j:=0 to MAXy - 1 do
         Temp[i][j]:=T[i][j];
end;

procedure PasteT;
var i,j:integer;
begin
 for i:=0 to MAXx - 1 do
     for j:=0 to MAXy - 1 do
         T[i][j]:=Temp[i][j];
end;

procedure ClearScreen;
begin
 Box(0,0,319,199,0);
end;

procedure ShowGraph;
var i,j,k:word;
    c:char;

begin
     k:=0;
     While k<MAXDraw do
     begin
     j:=0;
     ClearScreen;
     while (j<=(200-MAXy)) and (k<MAXDraw) do
           begin
           i:=0;
           while ((i<=(320-MAXx))) and (k<MAXDraw) do
                 begin
                     PrintGraph(k,i,j);
                     i:=i+MAXx;
                     k:=k+1;
                 end;
           j:=j+MAXy;
           end;
    c:=ReadKey;
    end;
    ClearScreen;

end;

procedure Shift(Vi,Vj:integer);
var i,j,xmin,xmax,ymin,ymax:integer;
begin
     CopyT;
     for i:=0 to MAXx do
         for j:=0 to MAXy do
             T[i,j]:=0;

     xmin:=0;
     ymin:=0;
     xmax:=MAXx;
     ymax:=MAXy;

     if (Vi = 1) then
            xmax:=MAXx-1
     else if (Vi=-1) then
            xmin:=1;

     if (Vj = 1) then
            ymax:=MAXy-1
     else if (Vj = -1) then
            ymin:=1;

     for i:=xmin to xmax do
         for j:=ymin to ymax do
             T[i,j]:=Temp[i+Vi,j+Vj];

end;


begin
  { Get file to read from command line : ParamStr(1) }
  OrigMode := LastMode;

  clrscr;
  Writeln('Sprite Maker :');
  Write('Enter File Name: ');
  if ParamStr(1)='' then Readln(s) else s:=ParamStr(1);
  Writeln;
  Writeln('You typed: ',s);

 if FileExists(s) then
   begin
   Writeln('File exists');
   OpenFile(s);
   OpenDraw(0);
   end
 else
   Begin
   Writeln('File not found');
   writeln('New file:',s);
   end;


 writeln('Press ENTER to start');
 readln;

DebutEdition:

 init_Mcga;
 i:=0;
 j:=0;
 No:=0;
 Continuer:=TRUE;

 while continuer do
 begin
  PrintTab;
  PrintGraph(No,200,0);
  box(i*TAILLE,j*TAILLE,(i+1)*TAILLE,(j+1)*TAILLE,6);
  DrawMouse;
  while Not(Keypressed) do
                begin
                     ReadMouse;
                     if (MouseX<(8*MAXx)) and (MouseY<(4*MAXy)) then
                       begin
                           if Button=1 then
                                       begin
                                       asm
                                       mov ax,MouseX
                                       sar ax,1
                                       sar ax,1
                                       sar ax,1
                                       mov k,ax
                                       mov ax,MouseY
                                       sar ax,1
                                       sar ax,1
                                       mov l,ax
                                       end;
                                       if t[k][l]=0 then
                                          begin
                                          T[k][l]:=1;
                                          MaskMouse;
                                          box(k*TAILLE,l*TAILLE,
                                          (k+1)*TAILLE-1,(l+1)*TAILLE-1,75);
                                          DrawMouse;
                                          end;
                                       end
                           else if Button=2 then
                                       begin
                                       asm
                                       mov ax,MouseX
                                       sar ax,1
                                       sar ax,1
                                       sar ax,1
                                       mov k,ax
                                       mov ax,MouseY
                                       sar ax,1
                                       sar ax,1
                                       mov l,ax
                                       end;
                                       if t[k][l]=1 then
                                          begin
                                          T[k][l]:=0;
                                          MaskMouse;
                                          box(k*TAILLE,l*TAILLE,
                                          (k+1)*TAILLE-1,(l+1)*TAILLE-1,18);
                                          DrawMouse;
                                          end;
                                       end;
                       end;
                       end;
  C := UpCase(Readkey);
  MaskMouse;

  if (c = ' ') then T[i][j]:=1
  else if (c = '2') then
                    Shift(0,1)
  else if (c = '8') then Shift(0,-1)
  else if (c = '4') then Shift(-1,0)
  else if (c = '6') then Shift(1,0)
  else if (c = 'W') then T[i][j]:=0
  else if c = 'H' then for k :=0 to MAXx - 1 do
                      T[k][j]:=1 - T[k][j]
  else if c = 'V' then for k :=0 to MAXy - 1 do
                      T[i][k]:=1 - T[i][k]
  else if c = chr(27) then Continuer := FALSE
  else if c = 'C' then CopyT
  else if c = 'P' then PasteT
  else if c = 'D' then
             begin
               CopyT;
               for k:=No to MAXDRAW-2 do for j:=0 to MAXy - 1 do
                for i:=0 to MAXD - 1 do Mem[i][j][k]:=Mem[i][j][k+1];
               for j:=0 to MAXy - 1 do
                for i:=0 to MAXD - 1 do Mem[i][j][MAXDRAW-1]:=0;
               OpenDraw(No);
             end
  else if (c= 'I') then
              begin
               SaveDraw(No);
               for k:=MAXDraw-2 downto No do for j:=0 to MAXy - 1 do
                for i:=0 to MAXD - 1 do Mem[i][j][k+1]:=Mem[i][j][k];
               for j:=0 to MAXy - 1 do for i:=0 to MAXD - 1 do
                        Mem[i][j][No]:=0;
               i:=0; j:=0;
               OpenDraw(No);
              end
  else IF (C= '+') and (No < MAXDRAW-1) then
              begin
                   SaveDraw(No);
                   No := No +1;
                   OpenDraw(No);
              end
  else if (C= '-') and (No>0) then
              begin
                  SaveDraw(No);
                  No := No - 1;
                  OpenDraw(No);
              end
  else if c = '0' then
             begin
                  SaveDraw(No);
                  No:=0;
                  OpenDraw(No);
             end
  else if c = 'S' then
             begin
                  SaveDraw(No);
                  SaveFile(s);
             end
  else if c = 'R' then
             begin
                  CopyT;
                  if MAXx = MAXy then
                            begin
                                 for i:=0 to MAXx-1 do
                                     for j:=0 to MAXy-1 do
                                         T[i][j]:=Temp[MAXy-1-j][i];
                            end;
             end
  else if c = 'M' then
             begin
                  CopyT;
                  for i:=0 to MAXx-1 do
                      for j:=0 to MAXy-1 do
                          T[i][j]:=Temp[MAXx-1-i][j];

             end
  else if c = 'L' then
             begin
                  CopyT;
                  for i:=0 to MAXx-1 do
                      for j:=0 to MAXy-1 do
                          T[i][j]:=Temp[i][MAXy-1-j];
             end
  else if c=chr(0) then
              begin
                  c:=ReadKey;
                  if c=';' then
                           begin
                             TextMode(OrigMode);
                             clrscr;
                             Writeln('S Save');
                             Writeln('R Rotate');
                             Writeln('L Mirror Vertical');
                             Writeln('M Mirror Horizontal');
                             Writeln('0 Start');
                             Writeln('+ / - Change Graph No');
                             Writeln('Copy Paste Delete Inser');
                             writeln('SPACE Put on, W put Off');
                             Writeln('Horizontal, Vertical xor line.');
                             Writeln('F1 Help, F2 all graphs');
                             Writeln('Mouse : ',MouseX,' ',MouseY,' ',Button);
                             Writeln('Press RETURN to continue');
                             Readln;
                             Init_Mcga;
                           end
                  else if (c='<') then ShowGraph
                  else if (c = 'K') and (i > 0) then i:= i - 1
                  else if (c = 'M') and (i< (MAXx - 1)) then i:= i + 1
                  else if (c = 'H') and (j>0) then j:=j-1
                  else if (c = 'P') and (j<(MAXy - 1)) then j:=j + 1;
              end;

  end;

 SaveDraw(No);
 OpenDraw(0);
 TextMode(OrigMode);
 writeln('Save ? (Yes / No / Cancel)');
  c:=' ';
  while ((c<>'Y') and (c<>'N') and (c<>'C')) do
        c:=upcase(readkey);
  if c='Y' then SaveFile(s);
  if c='C' then goto DebutEdition;


end.
