	include   "tios.h"
	include   "flib.h"
	include   "fargray.h"
	include   "gray7lib.h"

	xdef _main
	xdef _comment

_main:
	jsr	flib::zap_screen
	clr.w	-(a7)
	jsr	tios::ST_busy
	addq.l	#2,a7

	jsr     gray7lib::on            ; Turn on 7-grayscale
	move.l  gray7lib::plane0,a1     ; Remember plane
	move.l  gray7lib::plane1,a2     ; Remember plane
        cmp.b	#CALC_TI89,CALCULATOR
        bne	notti89
	lea     planes89(pc),a5           ; Set pointer to compressed data !
	move.w  #3000,d7                ; Number of bytes to paint.
	bra	done
notti89:
	lea     planes(pc),a5           ; Set pointer to compressed data !
	move.w  #3840,d7                ; Number of bytes to paint.
done:
	jsr     fargray::put3planepic   ; Put Picture on Screen !
	jsr     flib::idle_loop         ; Wait until keypressed.
	jsr     gray7lib::off           ; Turn off Grayscale
	rts

planes:
     	INCBIN	"introfer.bin"
planes89:
	INCBIN	"intro89.bin"
_comment:
        dc.b "Hello fernando",0

   end
