	include	"flib.h"
	include "tios.h"
	include	"Macros.h"

	xdef	_main
	xdef	_comment

STR_X		EQU	50
STR_Y		EQU	50
STR_FONT	EQU	GRAS

TITLE_O		EQU	400
TITLE_P		EQU	2402
TITLE_Q		EQU	2412
TITLE_R		EQU	3150

STR_X_89	EQU	30
STR_Y_89	EQU	40
STR_FONT_89	EQU	NORMAL

TITLE_O_89	EQU	6
TITLE_P_89	EQU	1560
TITLE_Q_89	EQU	1570
TITLE_R_89	EQU	2400

_main:
 SetFont  STR_FONT
 jsr	flib::zap_screen
 WriteStr #STR_X,#STR_Y,#4,Copyright

 move.l #LCD_MEM,a0

 lea	IntroPict(PC),a1
 lea	TITLE_O(a0),a2
 bsr	PutBigSprite

 clr.l    d3
 clr.l    d4
 clr.l    d5
 lea    $600000,a6
 bsr	WaitForNotKey

IntroLoop:
 clr.l	$18(a6)

 lea	IntroPict(PC),a1
 lea	256(a1),a1

 lea	TITLE_P(a0),a2
 add.l	d3,a2
 bsr	PutBigSprite

 lea	TITLE_Q(a0),a2
 add.l	d4,a2
 bsr	PutBigSprite

 lea	TITLE_R(a0),a2
 add.l	d5,a2
 moveq	#6,d0
\l4:
 moveq	#14,d1
\sl4:
 eori.w	#-1,(a2)+
 dbra	d1,\sl4
 lea	60(a2),a2
 dbra	d0,\l4

 moveq	#3,d0
 jsr	flib::random
 mulu.w	#30,d0
 move.w	d0,d3

 moveq	#3,d0
 jsr	flib::random
 mulu.w	#30,d0
 move.w	d0,d4

 moveq	#3,d0
 jsr	flib::random
 mulu.w	#30,d0
 move.w	d0,d5

\Wait:
 tst.b	$17(a6)
 bne	\Wait

; Delete a part of the screen !
 lea	2400(a0),a2
 move.l	#359,d0
\l0:
 clr.l	(a2)+
 dbf	d0,\l0

 move.b $1B(a6),d0		; Wait for all keys
 cmpi.b #$FF,d0
 beq	IntroLoop

 clr.w   tios::kb_vars+$1C

 rts

PutBigSprite:
 moveq	#31,d0
\l1:  
 move.l	(a1)+,(a2)+
 move.l	(a1)+,(a2)+
 lea	22(a2),a2
 dbra	d0,\l1
 rts

WaitForNotKey:
	clr.l	$18(a6)			; Mask to read keys
\WaitForQuit:
	move.b $1B(a6),d0		; Wait for all keys
	cmpi.b #$FF,d0			; to be released
	bne    \WaitForQuit
	rts


IntroPict	INCBIN Title.bin	; Title Graph

Copyright	dc.b "FERNANDO'S QUEST",0
_comment	dc.b "Intro for world 1",0

	end
