; OS
	include "kernel.h"
kernel::Exec	EQU	kernel::exec	

TI92		EQU	1
TI92PLUS	EQU	2
TI89		EQU	3

OS		EQU	TI92


; No de fichier	pour TI-92 & TI-92 II
HANDLEOK	EQU	1	; We will use the Handle I/O
HANDLEGRAPH	EQU	$0013	
HANDLEIO	EQU	$000F

; Files : ne sert plus  rien !
H_DEC1		EQU	26		; For Fargo 2
H_DEC2		EQU	2+H_DEC1	; For Fargo 2
H_DEC3		EQU	40		; For Fargo 2

; KeyBoard datas

Row_Key		EQU	9
WAIT_FOR_KEY	EQU	10	; Wait (.) instructions before reading

Jump_Key	EQU	3

Left_Key	EQU	4

Right_Key	EQU	6

Up_Key		EQU	5

Down_Key	EQU	7

Exit_Key_Test	MACRO
		btst.b	#0,(keystat-fer3c@0001)(a6)	; 2nd
		ENDM

Pause_Key_Test	MACRO
		btst.b	#2,(keystat-fer3c@0001)(a6)	; Shift to Pause
		ENDM

Speed1_Key_Test	MACRO
		btst.b	#4,(keystat+7-fer3c@0001)(a6)	; F5 
		ENDM

Speed2_Key_Test	MACRO
		btst.b	#4,(keystat+5-fer3c@0001)(a6)	; F6
		ENDM

Speed3_Key_Test	MACRO
		btst.b	#4,(keystat+3-fer3c@0001)(a6)	; F7
		ENDM

ReCenter_Key_Test	MACRO
		btst.b	#3,(keystat-fer3c@0001)(a6)
		ENDM

Statut_Key_Test	MACRO
		btst.b	#6,(keystat+6-fer3c@0001)(a6)
		ENDM

CONTRAST_UP_KEY_TEST	MACRO
		btst.b	#4,(keystat+8-fer3c@0001)(a6)	; '+'
		ENDM

CONTRAST_DOWN_KEY_TEST	MACRO
		btst.b	#0,(keystat+9-fer3c@0001)(a6)	; '-'
		ENDM

FREE_LOOK_KEY_TEST	MACRO
		btst.b	#4,(keystat+6-fer3c@0001)(a6)	; 'F1'
		ENDM


CHEAT_KEY	EQU	8243
CHEAT_KEY2	EQU	8249

KEY_LEFT	EQU	337
KEY_RIGHT	EQU	340
KEY_UP		EQU	338
KEY_DOWN	EQU	344
[2nd]		EQU	4096

KEY_PRESSED_FLAG	equ	tios::kb_vars+$1c
GETKEY_CODE		equ	tios::kb_vars+$1e

; Define fer3c as a library : include the right code...
LIBRARYOK	EQU	1

SetFont		macro
	move.w	#\1,-(a7)
	jsr	tios::FontSetSys
	addq.l	#2,a7
		endm

WriteStr	macro	;x,y,col,str
	move.w	\3,-(a7)
	pea	\4(pc)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
                endm

WriteStrA	macro	;x,y,col,An
	move.w	\3,-(a7)
	move.l	\4,-(a7)
	move.w	\2,-(a7)
	move.w	\1,-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
                endm
